// ---------------------------------------------------------------------
// JavaORB 2.0
//
//                        Object by value Tutorial
//
// Step 1 / Using value box
// ---------------------------------------------------------------------

public class Client
{

	public static void main( String [] args )
	{
		// 1.
		// Initialize the ORB
		org.omg.CORBA.ORB orb =	org.omg.CORBA.ORB.init(args,null);

		// 2.
		// Get the ValueExchange reference from	a file
		ValueExchange value	= null;
		org.omg.CORBA.Object obj = null;
		
		try
		{
			java.io.FileInputStream	file = new java.io.FileInputStream("ObjectId");
			java.io.DataInputStream	myInput	= new java.io.DataInputStream(file);
			String stringTarget	= myInput.readLine();
			
			obj	= orb.string_to_object(stringTarget);

		}
		catch (	java.io.IOException	ex )
		{
			System.out.println("File error");
			System.exit(0);
		}

		// 3.
		// Narrow the object reference
		value =	ValueExchangeHelper.narrow(obj);		

		// 4.
		// Use the ValueExchange object
		try
		{
			// We declare here a simple	value box
			longBox	aLongBox = new longBox(100);
			// Now,	we pass	our	simple value box to	server
			value.sendLongBox( aLongBox	);
			
			// The second call uses	complex	value box
			int	[] aLongSeqBox = new int[10];
			for	( int i=0; i<10; i++ )
				aLongSeqBox[i] = i;
			// Now pass	our	complex	value box to server
			value.sendLongSeqBox( aLongSeqBox );
			
			// We can also pass NULL as value
			value.sendLongBox( null );
			value.sendLongSeqBox( null );
		}
		catch (	org.omg.CORBA.SystemException ex )
		{
			System.out.println("A CORBA	System exception has been intercepted");
			System.out.println("");
			System.out.println(	ex.toString() );
		}
	}
}