// ---------------------------------------------------------------------
// JavaORB 2.0
//
//                        Object by value Tutorial
//
// Step 2 / Using simple value type
// ---------------------------------------------------------------------

/**
 * This class is the implementation of ValueExchange interface. It 
 * provides each operation that illustrates how to manage value box type.
 * 
 * @author	Jerome DANIEL
 * @version	1.0
 */
public class valueExampleImpl extends valueExample
{
	/**
	 * This operation must be implemented here. We inherit it from
	 * valueExample.
	 */
	public int number()
	{
		return number_state;
	}

	/**
	 * This operation must be also implemented here.
	 */
	public void print()
	{
		System.out.println("I'm the print operation");
		System.out.println("I'm a local operation");
		System.out.println("");
		System.out.println("My private value = " + number_state);
		System.out.println("My public value = " + name_state);
		System.out.println("");
	}		
	
	// ----------------------------------------------------
	//
	// Custom marshalling functions
	//
	// ----------------------------------------------------
	
	public void marshal( org.omg.CORBA.DataOutputStream os )
	{
		System.out.println("Message from marshalling...");
		System.out.println("");
		
		os.write_string("This value was marshalled by me");
		os.write_long(number_state);
		os.write_string(name_state);
	}
	
	public void unmarshal( org.omg.CORBA.DataInputStream is )
	{
		System.out.println("Message from unmarshalling...");
		System.out.println( is.read_string() );
		System.out.println("");
		
		number_state = is.read_long();
		name_state = is.read_string();
	}
}