// ---------------------------------------------------------------------
// JavaORB 2.0
//
//                        Object by value Tutorial
//
// Step 2 / Using simple value type
// ---------------------------------------------------------------------

public class Client
{

	public static void main( String [] args )
	{
		// 1.
		// Initialize the ORB
		org.omg.CORBA.ORB orb =	org.omg.CORBA.ORB.init(args,null);

		// 2.
		// Create a value factory
		ValueFactoryExample factory = new ValueFactoryExample();

		// 3.
		// Register the value factory
		((org.omg.CORBA_2_3.ORB)orb).register_value_factory( valueExampleHelper.id(), factory );
	
		// 4.
		// Get the ValueExchange reference from	a file
		ValueExchange value	= null;
		org.omg.CORBA.Object obj = null;
		
		try
		{
			java.io.FileInputStream	file = new java.io.FileInputStream("ObjectId");
			java.io.DataInputStream	myInput	= new java.io.DataInputStream(file);
			String stringTarget	= myInput.readLine();
			
			obj	= orb.string_to_object(stringTarget);

		}
		catch (	java.io.IOException	ex )
		{
			System.out.println("File error");
			System.exit(0);
		}
				
		// 5.
		// Narrow the object reference
		value =	ValueExchangeHelper.narrow(obj);		

		// 7.
		// Use the ValueExchange object
		try
		{
			Message msg = value.getValueSupportedInterface();
			
			msg.print();
			
			valueExample val = value.getValueExample();
			
			val.print();
			
			val.printName();
			
		}
		catch (	org.omg.CORBA.SystemException ex )
		{
			System.out.println("A CORBA	System exception has been intercepted");
			System.out.println("");
			System.out.println(	ex.toString() );
		}
	}
}