// ---------------------------------------------------------------------
// JavaORB 2.0
//
//                        Object by value Tutorial
//
// Step 8 / Value type cycles
// ---------------------------------------------------------------------

public class Client
{

	public static void main( String [] args )
	{
		// 1.
		// Initialize the ORB
		org.omg.CORBA.ORB orb =	org.omg.CORBA.ORB.init(args,null);

		// 2.
		// Create the value factories
		typeAFactory factory_A = new typeAFactory();
		typeBFactory factory_B = new typeBFactory();

		// 3.
		// Register the value factories
		((org.omg.CORBA_2_3.ORB)orb).register_value_factory( typeAHelper.id(), factory_A );
		((org.omg.CORBA_2_3.ORB)orb).register_value_factory( typeBHelper.id(), factory_B );
	
		// 4.
		// Get the ValueExchange reference from	a file
		Cycle value	= null;
		org.omg.CORBA.Object obj = null;
		
		try
		{
			java.io.FileInputStream	file = new java.io.FileInputStream("ObjectId");
			java.io.DataInputStream	myInput	= new java.io.DataInputStream(file);
			String stringTarget	= myInput.readLine();
			
			obj	= orb.string_to_object(stringTarget);

		}
		catch (	java.io.IOException	ex )
		{
			System.out.println("File error");
			System.exit(0);
		}
				
		// 5.
		// Narrow the object reference
		value =	CycleHelper.narrow(obj);		

		// 7.
		// Use the ValueExchange object
		try
		{
			typeA ta = value.getCycle();
			
			System.out.println("The received value : ");
			
			ta.printName();
			
			System.out.println("Its internal state : ");
						
			ta.b.printName();
			
			System.out.println("The internal state of its internal state : ");
			
			ta.b.a.printName();			
		}
		catch (	org.omg.CORBA.SystemException ex )
		{
			System.out.println("A CORBA	System exception has been intercepted");
			System.out.println("");
			System.out.println(	ex.toString() );
		}
	}
}