// ============================================================
// = CORBA Sample				                              =
// ============================================================

public class Server
{
	public static void main( String args[] )
	{
		// 1.
		// Initialize the ORB
		org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(args, null);

		// 2.
		// Resolve the RootPOA reference
		org.omg.CORBA.Object objPoa = null;
		org.omg.PortableServer.POA rootPOA = null;
		try
		{
			objPoa = orb.resolve_initial_references("RootPOA");			
		}
		catch ( org.omg.CORBA.ORBPackage.InvalidName ex )
		{}		

		// 3.
		// Narrow the object reference to POA reference
		rootPOA = org.omg.PortableServer.POAHelper.narrow(objPoa);		

		// 4.
		// Instanciate a Calculator object
		CalculatorImpl calc = new CalculatorImpl();
		
		try
		{
			// 5.
			// Activate the servant
			//byte[] servantId = rootPOA.activate_object(calc);

			// 6.
			// Get the servant reference
			//org.omg.CORBA.Object obj = rootPOA.id_to_reference(servantId);
			
			org.omg.CORBA.Object obj = calc._this(orb);

			// 7.
			// Export into a file the servant reference
			String reference = orb.object_to_string(obj);			
			try
			{
				java.io.FileOutputStream file = new java.io.FileOutputStream("ObjectId");
				java.io.PrintStream pfile=new java.io.PrintStream(file);
				pfile.println(reference);
				file.close();
			}
			catch ( java.io.IOException ex )
			{
				System.out.println("File error");
			}

			// 8.
			// Activate the POA by its manager way
			rootPOA.the_POAManager().activate();

			System.out.println("The server is ready...");
			
			// 9.
			// Run and wait for invocations		
			orb.run();
		}
		catch ( java.lang.Exception ex )
		{
			System.out.println("An exception has been intercepted");
			ex.printStackTrace();
		}

	}
}