// ============================================================
// = CORBA Sample											  =
// ============================================================

public class Client
{
	public static void main( String args[] )
	{		
		// 1.
		// Initialize the ORB
		org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(args,null);

		// 2.
		// Get the Calculatrice reference from a file
		Calculatrice calc = null;
		org.omg.CORBA.Object obj = null;
		try
		{			
			java.io.FileInputStream file = new java.io.FileInputStream("ObjectId");
			java.io.DataInputStream myInput = new java.io.DataInputStream(file);
			String stringTarget = myInput.readLine();
			
			obj = orb.string_to_object(stringTarget);

		}
		catch ( java.io.IOException ex )
		{
			System.out.println("File error");
			System.exit(0);
		}

		// 3.
		// Narrow the object reference
		calc = CalculatriceHelper.narrow(obj);		

		// 4.
		// Use the Calculatrice object
		try
		{
			System.out.println("5 + 3 = " + calc.addition(5,3) );

			System.out.println("5 / 0 = " + calc.division(5,0) );
		}
		catch ( DivisionParZero ex )
		{
			System.out.println("A division by zero has been intercepted");
			System.out.println("The division was "+ex.op1+" / "+ex.op2);
		}
		catch ( org.omg.CORBA.SystemException ex )
		{
			System.out.println("A CORBA System exception has been intercepted");
			System.out.println(ex.getMessage());
		}

	}
}