// ============================================================
// = CORBA Sample				                              =
// ============================================================

// Server with BOA

public class Server
{
	public static void main( String args[] )
	{
		// .1
		// Initialize the ORB
		org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(args,null);		

		// 2.
		// Initialize the BOA
		org.omg.CORBA.BOA boa = org.omg.CORBA.BOA.init(orb,args);

		// 3.
		// Instanciate Calculator object
		CalculatorImpl calc = new CalculatorImpl();
			
		// 4.
		// Connect the instance to BOA
		boa.connect(calc);
		
		// 5.
		// Activate the instance
		boa.obj_is_ready(calc);		
		
		// 6.
		// Resolve the NameService 
		org.omg.CORBA.Object obj = null;
		org.omg.CosNaming.NamingContextExt naming = null;
		try
		{			
			obj = orb.resolve_initial_references("NameService");
			naming = org.omg.CosNaming.NamingContextExtHelper.narrow(obj);
		}
		catch ( org.omg.CORBA.ORBPackage.InvalidName name )
		{
			System.out.println("Enable to resolve NameService");
			System.exit(0);
		}
		
		if ( naming == null )
		{
			System.out.println("The NameService was not found");
			System.exit(0);
		}
		
		// 7.
		// Build Calculator path 
		org.omg.CosNaming.NameComponent [] name = new org.omg.CosNaming.NameComponent[1];
		name[0] = new org.omg.CosNaming.NameComponent();
		name[0].id = "Calculator";
		name[0].kind = "Example";
		
		// 8. 
		// Bind Calculator into NameService
		try
		{
			naming.bind(name,calc);			
		}
		catch ( org.omg.CosNaming.NamingContextPackage.NotFound ex )			
		{
			System.out.println("Object not found");
			System.exit(0);
		}
		catch ( org.omg.CosNaming.NamingContextPackage.AlreadyBound ex )
		{
			System.out.println("Already bound");
			System.exit(0);
		}
		catch ( org.omg.CosNaming.NamingContextPackage.InvalidName ex )
		{
			System.out.println("Invalid name");
			System.exit(0);
		}
		catch ( org.omg.CosNaming.NamingContextPackage.CannotProceed ex )
		{
			System.out.println("Cannot proceed");
			System.exit(0);
		}
		
		// 9.
		// Wait for invocations
		try
		{
			System.out.println("The server is ready...");
			boa.impl_is_ready();
		}
		catch ( java.lang.Exception ex )
		{
			System.out.println("An exception has been intercepted.");
		}

	}
}