// ============================================================
// = CORBA Sample				                              =
// ============================================================

// Server with POA

public class ServerPOA
{
	public static void main( String args[] )
	{
		// 1.
		// Initialize the ORB
		org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(args, null);

		// 2.
		// Resolve the RootPOA reference
		org.omg.CORBA.Object objPoa = null;
		org.omg.PortableServer.POA rootPOA = null;
		try
		{
			objPoa = orb.resolve_initial_references("RootPOA");			
		}
		catch ( org.omg.CORBA.ORBPackage.InvalidName ex )
		{}		

		// 3.
		// Narrow the object reference to POA reference
		rootPOA = org.omg.PortableServer.POAHelper.narrow(objPoa);		

		// 4.
		// Instanciate a Calculator object
		CalculatorPOAImpl calc = new CalculatorPOAImpl();
		
		try
		{
			// 5.
			// Activate the servant
			byte[] servantId = rootPOA.activate_object(calc);

			// 6.
			// Get the servant reference
			org.omg.CORBA.Object ref = rootPOA.id_to_reference(servantId);

			// 6.
			// Resolve the NameService 
			org.omg.CORBA.Object obj = null;
			org.omg.CosNaming.NamingContext naming = null;
			try
			{			
				obj = orb.resolve_initial_references("NameService");
				naming = org.omg.CosNaming.NamingContextHelper.narrow(obj);
			}
			catch ( org.omg.CORBA.ORBPackage.InvalidName name )
			{
				System.out.println("Enable to resolve NameService");
				System.exit(0);
			}
		
			if ( naming == null )
			{
				System.out.println("The NameService was not found");
				System.exit(0);
			}
		
			// 7.
			// Build Calculator path 
			org.omg.CosNaming.NameComponent [] name = new org.omg.CosNaming.NameComponent[1];
			name[0] = new org.omg.CosNaming.NameComponent();
			name[0].id = "Calculator";
			name[0].kind = "Example";
		
			try
			{
				naming.bind(name,ref);
			}
			catch ( org.omg.CosNaming.NamingContextPackage.NotFound ex )			
			{
				System.out.println("Object not found");
				System.exit(0);
			}
			catch ( org.omg.CosNaming.NamingContextPackage.AlreadyBound ex )
			{	
				System.out.println("Already bound");
				System.exit(0);
			}
			catch ( org.omg.CosNaming.NamingContextPackage.InvalidName ex )
			{
				System.out.println("Invalid name");
				System.exit(0);
			}
			catch ( org.omg.CosNaming.NamingContextPackage.CannotProceed ex )
			{
				System.out.println("Cannot proceed");
				System.exit(0);
			}
				
			// 8.
			// Activate the POA by its manager way
			rootPOA.the_POAManager().activate();

			System.out.println("The server is ready...");
			
			// 9.
			// Run and wait for invocations		
			orb.run();
		}
		catch ( java.lang.Exception ex )
		{
			System.out.println("An exception has been intercepted");
			ex.printStackTrace();
		}

	}
}